"use strict";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const curry = require('lodash/curry');

const warning = require('warning');

const effect = (effectFn, action) => {
  const fn = async (context, ...otherArgs) => {
    const {
      derivedState,
      derivedParam,
      derivedProps
    } = (await effectFn(context, ...otherArgs)) || {};

    if (derivedState) {
      context.setState(derivedState);
    }

    warning(!derivedParam, '`derivedParam` is deprecated. Use `derivedProps` instead.');

    if (derivedParam || derivedProps) {
      const [param, ...argsFromIndex2] = otherArgs;

      if (!param || typeof param === 'object') {
        return action(context, _objectSpread({}, param, {}, derivedParam, {}, derivedProps), ...argsFromIndex2);
      }
    }

    return action(context, ...otherArgs);
  };

  const name = `Effect(${action.name || 'Anonymous'})`;
  Object.defineProperty(fn, 'name', {
    value: name
  });
  return fn;
};

module.exports = curry(effect);